//  ----------------
//  FI_CAO
//  ----------------

unit ColorUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, Grids, StdCtrls, Buttons;

type
  TColorForm = class(TForm)
    PbR: TPaintBox;
    PbG: TPaintBox;
    PbB: TPaintBox;
    SG: TStringGrid;
    Panel1: TPanel;
    PnlInfo: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure PbRPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PbRMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PbRMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PbRMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SGDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure SGClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    FBitmap: TBitmap;
    FPos: array[0..2] of Byte;
    FDragging: Boolean;

    FResult: TColor;

    procedure   ShowNumber();
  public
    { Public 錾 }
  end;

//var
//  ColorForm: TColorForm;

function ChooseColor(Owner: TComponent; var C: TColor): Boolean;

implementation

{$R *.dfm}

uses
    Misc;

(*
    -----------------------------------------------------------------
    FI_CAO
    -----------------------------------------------------------------
*)
function ChooseColor(Owner: TComponent; var C: TColor): Boolean;
var
    Form: TColorForm;
begin
    Result := false;
    Form := TColorForm.Create(Owner);
    try
        Form.FResult := ColorToRGB(C);
        if (Form.ShowModal() = mrOK) then
        begin
            C := Form.FResult;
            Result := true;
        end;
    finally
        Form.Free;
    end;
end;

//------------------------------------------------------------------------
//  RXgN^
procedure TColorForm.FormCreate(Sender: TObject);
begin
    //  ʒu
    Top := Application.MainForm.Top + Application.MainForm.Height;

    //  F}bvp
    FBitmap := TBitmap.Create;
    //  ԁE΁E̃Of[V쐬
    DrawColorMap(FBitmap);

    //  hbOtO
    FDragging := false;

    //  Iʒu
    FPos[0] := 0;   //  
    FPos[1] := 0;   //  
    FPos[2] := 0;   //  

    //  }
    PbR.ControlStyle := PbR.ControlStyle + [csOpaque];
    PbG.ControlStyle := PbG.ControlStyle + [csOpaque];
    PbB.ControlStyle := PbB.ControlStyle + [csOpaque];

    //  ʒu\p\̐F
    PbR.Canvas.Pen.Color := clWhite;
    PbG.Canvas.Pen.Color := clWhite;
    PbB.Canvas.Pen.Color := clWhite;

    //  ObhWEBF
    InitHTMLColorMap(SG);
end;

//------------------------------------------------------------------------
//  fXgN^
procedure TColorForm.FormDestroy(Sender: TObject);
begin
    FBitmap.Free;
end;

//------------------------------------------------------------------------
//  \
procedure TColorForm.FormShow(Sender: TObject);
begin
    //  IF
    FPos[0] := GetRValue(FResult);
    FPos[1] := GetGValue(FResult);
    FPos[2] := GetBValue(FResult);
end;

//------------------------------------------------------------------------
//  Fl\
procedure   TColorForm.ShowNumber();
begin
    PnlInfo.Color := RGB(FPos[0], FPos[1], FPos[2]);
    PnlInfo.Caption := Format('[Color] R:%3.3d G:%3.3d B:%3.3d', [FPos[0], FPos[1], FPos[2]]);
end;

//------------------------------------------------------------------------
//  I
procedure TColorForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
    FResult := RGB(FPos[0], FPos[1], FPos[2]);
end;

//------------------------------------------------------------------------
//  F}bv`
procedure TColorForm.PbRPaint(Sender: TObject);
var
    P: TPaintBox;
begin
    P := TPaintBox(Sender);
    //  쐬ς݂̃Of[VԁE΁E̂ꂩ`
    StretchBlt(P.Canvas.Handle, 0, 0, P.Width, P.Height,
               FBitmap.Canvas.Handle, 0, P.Tag, P.Width, 1, SRCCOPY);
    //  Iʒu\p\`
    DrawCrossCursor(P.Canvas, FPos[P.Tag], 6);
    ShowNumber();
end;

(*
    =================================================================
    PaintBox:J[\ړ͈͂
    IFXV
    -----------------------------------------------------------------
    http://www5d.biglobe.ne.jp/~tomoya03/shtml/vbapi/ClipCursor.htm
    Platform SDK
    =================================================================
*)
procedure TColorForm.PbRMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
    PB: TPaintBox;
    ClipRect: TRect;
begin
    PB := TPaintBox(Sender);
    //  J[\
    ClipRect := ClientRectToScreenRect(PB);
    ClipCursor(@ClipRect);
    FDragging := true;
    //  }EXMOVE
    PB.OnMouseMove(Sender, Shift, X, Y);
end;

//------------------------------------------------------------------------
//  FI
procedure TColorForm.PbRMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
    PB: TPaintBox;
begin
    PB := TPaintBox(Sender);
    if FDragging then
    begin
        FPos[PB.Tag] := X;
        PB.Repaint();
    end;
end;

(*
    =================================================================
    PaintBox:J[\ړ͈͂tXN[
    -----------------------------------------------------------------
    [Delphi:44951] Re: }EXIy[VȂ@ɂ
    =================================================================
*)
procedure TColorForm.PbRMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    FDragging := false;
    //  J[\
    ClipCursor(nil);
end;

//------------------------------------------------------------------------
//  FObh`
procedure TColorForm.SGDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
    Grid: TStringGrid;
begin
    Grid := TStringGrid(Sender);

    if (gdFixed in State) then
    begin
        Grid.Canvas.Brush.Color := Grid.FixedColor;
        Grid.Canvas.FillRect(Rect);
    end
    else
    begin
//        Grid.Canvas.Brush.Color := HTMLToColor(Grid.Cells[ACol, ARow]);
        Grid.Canvas.Brush.Color := StrToInt(Grid.Cells[ACol, ARow]);
        Grid.Canvas.FillRect(Rect);
        if (gdFocused in State) or (gdSelected in State) then
        begin
            Grid.Canvas.Brush.Color := clBlack;
            Grid.Canvas.FrameRect(Rect);
        end;
    end;
end;

//------------------------------------------------------------------------
//  ObhŐFI
procedure TColorForm.SGClick(Sender: TObject);
var
    G: TStringGrid;
    C: TColor;
begin
    G := TStringGrid(Sender);
    C := StrToInt(G.Cells[G.Col, G.Row]);
//    C := HTMLToColor(G.Cells[G.Col, G.Row]);
    FPos[0] := GetRValue(C);
    FPos[1] := GetGValue(C);
    FPos[2] := GetBValue(C);
    PbR.Repaint();
    PbG.Repaint();
    PbB.Repaint();
end;

end.

