unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Longo, ComCtrls;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    EditW: TEdit;
    EditH: TEdit;
    UdH: TUpDown;
    UdW: TUpDown;
    ScrollBox1: TScrollBox;
    PBox: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PBoxPaint(Sender: TObject);
    procedure EditWChange(Sender: TObject);
    procedure PBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    FDragging: Boolean;
    FStartX: integer;
    FStartY: integer;
    FMoveX: integer;
    FMoveY: integer;
    procedure   LayerRelativeMove(const index: integer; L: TLongoLayer);
  public

  end;

procedure   KickMain();

var
  MainForm: TMainForm;

implementation

uses
    Misc;

{$R *.dfm}

//------------------------------------------------------------------------
//  O̍XV
procedure   KickMain();
begin
    MainForm.PBox.Repaint();
end;

//------------------------------------------------------------------------
//  RXgN^
procedure TMainForm.FormCreate(Sender: TObject);
begin
    LongoLongo := TLongoLongo.Create(PBox.Width, PBox.Height);
//    LongoLongo.SetBaseFont(PBox.Canvas.Font);
    LongoLongo.Font := PBox.Canvas.Font;

    PBox.ControlStyle := PBox.ControlStyle + [csOpaque];

    SetEditNumbersOnly(EditW);
    SetEditNumbersOnly(EditH);

    FDragging := false;
end;
//------------------------------------------------------------------------
//  fXgN^
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    LongoLongo.Free();
end;

//------------------------------------------------------------------------
//  ĕ`
procedure TMainForm.PBoxPaint(Sender: TObject);
begin
    LongoLongo.Draw(PBox.Canvas);
end;

//------------------------------------------------------------------------
//  TCYύX
procedure TMainForm.EditWChange(Sender: TObject);
var
    E: TEdit;
begin
    E := TEdit(Sender);

    //  ̏ꍇ
    if (E = EditW) then
    begin
        if (StrToIntDef(E.Text, 0) < 1) then E.Text := IntToStr(UdW.Position);
        PBox.Width := StrToInt(E.Text);
        LongoLongo.ChangeWidth(PBox.Width);
    end
    //  ̏ꍇ
    else if (E = EditH) then
    begin
        if (StrToIntDef(E.Text, 0) < 1) then E.Text := IntToStr(UdH.Position);
        PBox.Height := StrToInt(E.Text);
        LongoLongo.ChangeHeight(PBox.Height);
    end;

    PBox.Repaint();
end;

//------------------------------------------------------------------------
//  炵
procedure   TMainForm.LayerRelativeMove(const index: integer; L: TLongoLayer);
begin
    L.RelativeMove(FMoveX, FMoveY);
end;

//------------------------------------------------------------------------
//  炵Jn
procedure TMainForm.PBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    FDragging := true;
    FStartX := X;
    FStartY := Y;
end;

//------------------------------------------------------------------------
//  炵
procedure TMainForm.PBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
    if not FDragging then exit;

    FMoveX := X - FStartX;
    FMoveY := Y - FStartY;
    FStartX := X;
    FStartY := Y;

    //  IĂ邩
    if (LongoLongo.SelCount = 0) then exit;
    //  ړ
    VisitSelectedLayer(true, LayerRelativeMove);
    //  ĕ`
    KickMain();

end;

//------------------------------------------------------------------------
//  炵
procedure TMainForm.PBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if not FDragging then exit;
    FDragging := false;

    FMoveX := X - FStartX;
    FMoveY := Y - FStartY;

    //  IĂ邩
    if (LongoLongo.SelCount = 0) then exit;
    //  ړ
    VisitSelectedLayer(true, LayerRelativeMove);
    //  ĕ`
    KickMain();
end;

end.
